package MyApp::DB;
use strict;
use warnings;

use DBIx::Handler;

{
    my @dsn = ("DBI:mysql:database=myapp;host=localhost;port=3306;", "root", "");
    my $handler;
    sub get {
        $handler ||= do {
            DBIx::Handler->new(@dsn, {
                RootClass => "DBIx::Sunny",
                PrintError => 0,
                RaiseError => 1,
            });
        };

        return $handler->dbh;
    }

    sub overwrite_dsn {
        my ($class, @new_dsn) = @_;
        @dsn = @new_dsn;
        $class->reset;
    }

    sub reset {
        undef $handler;
    }
}

1;
