package MyApp::DB::Schema;
use strict;
use warnings;

use DBIx::Schema::DSL;
database "MySQL";
create_database "myapp";

create_table users => columns {
    integer id => primary_key, auto_increment;
    varchar name => not_null;
    integer avatar_id => not_null;
    integer energy => not_null, default => 100;
    varchar session => not_null;

    add_unique_index session__idx => [qw/session/];
};

create_table friends => columns {
    integer id => primary_key, auto_increment;
    integer user_a_id => not_null;
    integer user_b_id => not_null;

    add_index user_a__user_b_id__idx => [qw/user_a_id user_b_id/];
};

create_table items => columns {
    integer id => primary_key, auto_increment;
    varchar name => not_null;
    integer effect_type  => not_null;
    varchar effect_parameter => not_null, default => "{}";
};

create_table user_items => columns {
    integer id => primary_key, auto_increment;
    integer user_id => not_null;
    integer item_id => not_null;
    integer having_num => not_null, default => 0;

    add_unique_index user_id__item_id__idx => [qw/user_id item_id/];
};

1;
