package MyApp::Model::ItemEffect::RecoverEnergy;
use strict;
use warnings;

use Mouse;
use constant {
    ENERGY_MAX => 1000,
};

has "effect_parameter" => (
    is => "rw",
    isa => "HashRef",
);

no Mouse;

sub new_by_parameter {
    my ($class, $parameter) = @_;

    return $class->new(effect_parameter => $parameter);
}

sub effect {
    my ($self, %args) = @_;
    my $user = $args{user};
    my $num = $args{num};

    my $energy_base = $self->effect_parameter->{energy};
    my $energy = $user->energy + $energy_base * $num;
    $energy = ENERGY_MAX if $energy > ENERGY_MAX;

    $user->set_energy($energy);

    return $user->info;
}

1;
