package MyApp::Model::UserItems;
use strict;
use warnings;

use MyApp::Model::UserItem;
use Mouse;

extends "MyApp::Model::Base";

has user => (
    is => "rw",
    isa => "MyApp::Model::User",
);

has user_items => (
    is => "rw",
    isa => "ArrayRef[MyApp::Model::UserItem]",
);

no Mouse;

sub new_by_user {
    my ($class, $user) = @_;

    return $class->new(user => $user);
}

sub add {
    my ($self, %args) = @_;
    my $item_id = $args{item_id};
    my $num = $args{num};

    my $user_item = $self->user_item_by_item_id($item_id);

    my $txn = $self->dbh->txn_scope;
    $user_item->add(num => $num);
    $txn->commit;

    return $user_item;
}

sub user_item_by_item_id {
    my ($self, $item_id) = @_;

    my $user_item = MyApp::Model::UserItem->new;
    $user_item->build(user => $self->user, item_id => $item_id);

    return $user_item;
}

1;
