use strict;
use warnings;
use Test2::V0;
use MyApp::Test::DB;

MyApp::Test::DB->init;

use MyApp::DB;
use MyApp::Model::User;
use MyApp::Model::Friend;

dbtest "build" => sub {
    my $user_a = MyApp::Model::User->new;
    $user_a->build(name => "bob", avatar_id => 1);
    my $user_b = MyApp::Model::User->new;
    $user_b->build(name => "alice", avatar_id => 2);

    my $friend_rel = MyApp::Model::Friend->new;
    $friend_rel->build(user_a => $user_a, user_b => $user_b);

    like $friend_rel->info, hash {
        field friend => hash {
            field user_a => $user_a->info;
            field user_b => $user_b->info;
        };
    };

    my $dbh = MyApp::DB->get;
    my $rows = $dbh->select_all(<<SQL);
SELECT * FROM friends;
SQL

    like $rows, bag {
        item hash {
            field user_a_id => $user_a->id;
            field user_b_id => $user_b->id;
        };
        item hash {
            field user_a_id => $user_b->id;
            field user_b_id => $user_a->id;
        };
    };
};

done_testing;
