use strict;
use warnings;
use Test2::V0;
use MyApp::Test::DB;

MyApp::Test::DB->init;

use MyApp::DB;
use MyApp::Model::User;
use MyApp::Model::Friend;
use MyApp::Model::Friends;

dbtest "info" => sub {
    my $alice = MyApp::Model::User->new;
    $alice->build(name => "alice", avatar_id => 1);
    my $bob = MyApp::Model::User->new;
    $bob->build(name => "bob", avatar_id => 2);
    my $charlie = MyApp::Model::User->new;
    $charlie->build(name => "charlie", avatar_id => 3);

    for my $friend_user ($bob, $charlie) {
        my $friend_rel = MyApp::Model::Friend->new;
        $friend_rel->build(user_a => $alice, user_b => $friend_user);
    }

    my $friends = MyApp::Model::Friends->new_by_user($alice);
    my $friends_info = $friends->info;

    is $friends_info, hash {
        field friends => bag {
            item hash {
                field id => $bob->id;
                field name => "bob";
            };
            item hash {
                field id => $charlie->id;
                field name => "charlie";
            };
        };
    };
};

done_testing;
