use strict;
use warnings;
use Test2::V0;
use MyApp::Test::DB;

MyApp::Test::DB->init;

use MyApp::DB;
use MyApp::Model::User;

dbtest "build => new_by_user_id" => sub {
    my $user = MyApp::Model::User->new;
    my $name = "John Doe";
    my $avatar_id = 1;
    $user->build(name => "John Doe", avatar_id => 1);

    my $info = $user->info;
    like $info, hash {
        field user => hash {
            field id => qr/\d+/;
            field name => $name;
            field avatar_id => $avatar_id;
            field energy => 100;
        };
    };

    my $user_id = $info->{user}->{id};
    my $new_user = MyApp::Model::User->new_by_user_id($user_id);

    is $new_user->info, $info;
};

done_testing;
