use strict;
use warnings;
use Test2::V0;
use MyApp::Test::DB;

MyApp::Test::DB->init;

use FindBin qw/$Bin/;
use MyApp::DB;
use MyApp::Model::User;
use MyApp::Model::UserItems;
use DBIx::FixtureLoader;

dbtest "consume" => sub {
    my $user = MyApp::Model::User->new;
    $user->build(name => "bob", avatar_id => 1);
    my $user_items = MyApp::Model::UserItems->new_by_user($user);
    my $user_item = $user_items->add(item_id => 1, num => 3);

    my $loader = DBIx::FixtureLoader->new(dbh => MyApp::DB->get);
    $loader->load_fixture("$Bin/../../master-data/csv/items.csv");

    my $result = $user_item->consume(num => 2);

    like $result, hash {
        field user => hash {
            id => $user->id,
            energy => 160,
        };
        field user_item => hash {
            item_id => 1,
            having_num => 1,
        };
    };
};

done_testing;
