use strict;
use warnings;
use Test2::V0;
use MyApp::Test::DB;

MyApp::Test::DB->init;

use MyApp::DB;
use MyApp::Model::User;
use MyApp::Model::UserItems;

dbtest "add" => sub {
    my $user = MyApp::Model::User->new;
    $user->build(name => "bob", avatar_id => 1);

    my $user_items = MyApp::Model::UserItems->new_by_user($user);
    my $user_item = $user_items->add(item_id => 1, num => 3);
    is $user_item->having_num, 3;

    my $plus_user_item = $user_items->add(item_id => 1, num => 4);
    is $plus_user_item->having_num, 7;
};

done_testing;
