# WEB+DB PRESS Vol.102 連載「Perl Hackers Hub」サンプルコード

技術評論社刊「WEB+DB PRESS Vol.102」の連載「Perl Hackers Hub」第48回「Perlでの今風のゲームサーバ開発とテスト」（谷脇真琴著）のサンプルコードです。

## このサンプルコードの概要

このサンプルコードには、記事で解説した以下の3つが含まれています。

* MySQLを使ったテストの仕組み
    * `.proverc`および、`lib/MyApp/Test/DB.pm`の仕組みの記述があります。
    * `t/model`および、`t/controller`以下では、`lib/MyApp/Test/DB.pm`を用いてMySQLを使ったテストを記述しています。
* アイテムの挙動をマスタデータで記述する仕組み
    * `lib/MyApp/Model/UserItem.pm`および、`lib/MyApp/Model/Item.pm`、`lib/MyApp/Model/ItemEffector/RecoverEnergy.pm`に記事に出てきたソースコードの動作するものがあります。
* マスタデータのテスト
    * `t/master-data/items.csv`に`master-data/csv/items.csv`に記述されたCSVをテストするコードがあります。

## 実行方法

あらかじめ、plenvやperlbrewなどでPerl環境を用意し、`Carton`を導入してください。

まず、`MyApp`以下に移動し、依存モジュールをインストールします。

```console
$ cd MyApp
$ carton install
```

インストールが完了したら、テストを動かします。

```console
$ carton exec prove -lvr t
```

このテスト中では、mysqldが`App::Prove::Plugin::MySQLPool`によって起動して使われています。

Webサーバとして起動するには、`script/myapp-server`を実行します。

```console
$ script/myapp-server
```

5000番ポートで起動するので、curlなどで叩いてみてください。APIのエンドポイントは`lib/MyApp/Controller.pm`に記述があり、`t/controller.t`に結合テストがあります。